#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> MIDAS interface for MIDASsort                           <--#
#-->                                                         <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 11/27/02                       <--#
#-->  V Pucknell  2005
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#-->                                                         <--#
#-->  Variable definitions                                   <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

##########################
#    Use CARE with WinEdt
##########################
##########################
#    Caution - When editing don't edit out hidden tabs  -   nasty make feature
##########################
##########################

set mydebug          0
set frame          MIDASsort
set title          "Sort Control Frame"
set icon           MIDASsort

switch $env(os)  {
     SunOS          {set Build "1st Oct 2006"}
     Linux64        {set Build "17 Aug 2011"}
     Linux          {set Build "17 Apr 2009"}
     Win            {set Build "1st Oct 2006"}
     default {}
}

if {![info exists env(MIDASsortBase)]} then {set env(MIDASsortBase) [file join $env(MIDASBASE) MIDASSort]}

if {$env(os) == "Windows NT"} {set env(os) "Win"}

switch $env(os)  {
     SunOS          {set mediastring    [list Disc Online Tape GANILOnline]}
     Linux64 -
     Linux          {set mediastring    [list Disc Online Tape GANILOnline]}
     Win            {set mediastring    [list Disc Online GANILOnline]}
     default {}
}

switch $env(os)  {
     SunOS          {set fmtstring      [list "MIDAS" "Eurogam" "Grain" "Exogam" "GREAT" "GREAT (EB)" "Null"]}
     Linux64 -
     Linux          {set fmtstring      [list "MIDAS" "Eurogam" "Grain" "Exogam" "GREAT" "GREAT (EB)" "Null"]}
     Win            {set fmtstring      [list "MIDAS" "Eurogam" "Grain" "Exogam" "GREAT"  "Null"]}
     default {}
}

set tstring        "Drive"
set srstate        "Halted"
set ssavedir       $env(HOME)
set sortfilename   ""
set execfilename   ""
set compileoptions ""
set data_type      0
set directory      $env(HOME)
set gaindirectory  $env(HOME)
set gatedirectory  $env(HOME)
set file_status    "Not Chosen"
set sortdatadir    $env(HOME)
set idf            ""
set odf            ""
set indev          0
set infmt          0
set input_type     "Disc"
set output_typeo   "0"
set file_list      " "
set dclist         ""
set abortflag      0
set running        0
set started        0
set paused         0
set SortPid        0
set imedia         0
set ifmt           1
set ffmt           0
set diskffmt       3
set bfmt           32768
set dstart         0
set dstop          1
set numitapes      1
set startitape     0
set imedianum      0
set tfctr          0
set debugsort      0
set dsize          0
set simedianame    ""
set imediaselect   -1
set imediahdr      { "Tape    Run" }
set imediavals     { }
set list_vals      { }
set list_select    0
set atext          ""
set dtext          ""
set configtable    "NULL"
set cfglist        ""
set cfgstart       2
set overwritespec  1
set usegcc         1
set usegfortran    0
set usesssnc       0
set midassortbase  $env(MIDASsortBase)
set makefilepath   $env(HOME)


set cft_name       "" 
set cft_grp        "" 
set cft_item       "" 
set cft_label      "" 
set cft_enable     1 
set cft_bits       ""
set thist          1
set update_time    5000
set update         1
set kmemsas        0
set slmemalloc     [ list "Name           Port     Capability" ]
set sldaemons      [ list "Port   PID    Owner" ]  
for {set i 1} {$i <=16} {incr i} {set uv$i 0}
set vdpos          7
set vdaspos        1
set userexpt       0
set tracesort      0
set tracelevel     0
set csdev0value    0
set shmvalue       0
set shmconstant    1
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
set debuglevel(all)                   0
set debuglevel(maina)                 0
set debuglevel(main)                  0
set debuglevel(spectra)               0
set debuglevel(end_prog)              0
set debuglevel(decipher)              0
set debuglevel(get_block)             0
set debuglevel(parse_args)            0
set debuglevel(user0)                 0
set debuglevel(user1)                 0
set debuglevel(user2)                 0
set debuglevel(user3)                 0
set debuglevel(user4)                 0
set debuglevel(sortcalls)             0
set debuglevel(inc1d)                 0
set debuglevel(inc2d)                 0
set debuglevel(ucid)                  0
set debuglevel(ugm)                   0
set debuglevel(uinteract)             0
set debuglevel(shared)                0
set debuglevel(hist)                  0
set debuglevel(tback)                 0
set debuglevel(gate)                  0
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
set preflist [ list \
    {updateTime} {inputDevice} {inputFormat} \
    {sortDir} {sortDataDir} {gainDir} \
    {gateDir} {makeFilePath} {configTable} \
    {useGCCcompilers} {useGFortran} {useSunSortSpecNameConv} {killMemsasOnExit} \
    {inDiskFormat} {userVar01} {userVar02} {userVar03} {userVar04} \
    {userVar05} {userVar06} {userVar07} {userVar08} {userVar09} \
        {userVar10} {userVar11} {userVar12} {userVar13} {userVar14} \
    {userVar15} {userVar16} {vdposGLOB} {vdasposGLOB}
]

set shmstrings     [list { "Please Choose" } \
                     { "sort_action (0/1/-1)"} { "toggle sort debugging"} { "toggle histogramming"} \
                     { "useri [ 0 ]"} { "useri [ 1 ]"} { "useri [ 2 ]"} { "useri [ 3 ]"} \
                     { "userui[ 0 ]"} { "useriu[ 1 ]"} { "useriu[ 2 ]"} { "useriu[ 3 ]"} \
                     { "users [ 0 ]"} { "users [ 1 ]"} { "users [ 2 ]"} { "users [ 3 ]"} \
                     { "usersf[ 0 ]"} { "usersf[ 1 ]"} { "usersf[ 2 ]"} { "usersf[ 3 ]"} \
             { "Toggle trace"} { "Trace level (0-5)"} \
             { "BadJohn"} ]
             
set shmindex [ list {0} \
                {1} {2} {2} \
                {5} {6} {7} {8} \
            {9} {10} {11} {12} \
            {13} {14} {15} {16} \
            {18} {19} {20} {21} \
            {30} {31} \
            {99} \
        ]


#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> browse_sortfile.tcl                                     <--#
#-->                                                         <--#
#--> This routine launches the inbuilt directory browser     <--#
#--> and returns the name of the chosen file to the          <--#
#--> main program (sortfilename)                             <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc filestatus_midas_sort {} {
    global env sortfilename

    switch $env(os) {
        SunOS -
        Linux64 -
        Linux    {set execfilename [file rootname $sortfilename]}   ;#   name of executable
        Win      {set execfilename [file rootname $sortfilename].exe}
    }
    if {![file readable $execfilename]} {
        return 0   ;# there is not an executable file
    }

#    check required files are present in temp directory

     midas-check-for-temp     ;#  will cd into temp directory
     if {![file readable specarray]} then {return 3}   ;#   must recompile

    file stat $execfilename execfstat   ;# file readable - obtain modification time
    file stat $sortfilename sortfstat   ;# same for the sort file

    if {$execfstat(mtime) < $sortfstat(mtime)} then {
        return 2     ;#    executeable is older than source 
    } else {
        return 1     ;#    executeable is newer than source
    }
}

proc browse_sortfile {args} {
    global env sortfilename directory
    global file_status execfilename

    option add *Canvas.background  #c0c020
    set types {
    { {MIDAS Sort Files} {*.c *.f *.sfm} }
    { {C Source Files } {*.c} }
    { {MIDAS Sort Files} {*.sfm} }
    { {F77 Source Files } {*.f} }
    { {All Files } {*} }
    }

    set file [tk_getOpenFile -parent [self frame-name] \
          -title "Input SortFile Selection"  \
          -initialdir $directory -filetypes $types]
    option add *Canvas.background  $env(tkcanvasbackground)
    if {$file == ""} then {return}

    set_directory W [file dirname $file]   ;#  remember current choice

    set sortfilename $file
    :modify TSORTFILE :value $sortfilename

#--> To ensure that we can see the last bit of the string <--#
    [:path TSORTFILE].entry xview 200

#--> What is the status of this file ....?                <--#

    switch [filestatus_midas_sort]  {
    0     { set file_status "To BE Compiled" }
    1     { set file_status "Compiled"}
    2     { set file_status "Exe file older than src" }
    3     { set file_status "Please recompile" }
    }

    :modify STATE :label $file_status
    :modify BCOMPILE :inactive F

#--> Now extract the executable filename
#    if sortfile is   simple.c   then executable is simple

    switch $env(os) {
        SunOS -
        Linux64 -
        Linux    {set execfilename [file rootname $sortfilename]}   ;#   name of executable
        Win      {set execfilename [file rootname $sortfilename].exe}
    }
    
    UpdateRunState
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> tsortfile.tcl                                           <--#
#-->                                                         <--#
#--> This tcl file handles the direct typing of the          <--#
#--> sortfilename into the control window.                   <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc tsortfile arg {
    global env sortfilename directory
    global file_status

    set sortfilename $arg
    puts $sortfilename

#--> What is the status of this file ....?                <--#

    switch [filestatus_midas_sort] {
    0     { set file_status "To BE Compiled" }
    1     { set file_status "Compiled"}
    2     { set file_status "Exe file older than src" }
    3     { set file_status "Please recompile" }
    }

    :modify STATE :label $file_status

    :modify BCOMPILE :inactive F

#--> To ensure that we can see the last bit of the string <--#
    [:path TSORTFILE].entry xview 200

    UpdateRunState

}

proc Edit_Xlate {text}  {
    global env __editxlatedone

  :frame "[self frame-name].textedit" :label "[self frame-title]" :show-footer T  :resize F :toplevel T \
      :icon-image "@$env(ICONHOME)/default" \
      :icon-name "[self icon-title]"

    set __editxlatedone 0
  
    :panel TEXTEDITPANEL :layout T :padx 10 :pady 10
      :layout H; :row-gap 5; :col-gap 20

    :galley TEXTEDIT :rows 30 :cols 80 :font fixed
     :next-row T

    :button TEXTEDITDONE :label "Save file and finish"     :command Edit_Xlate_done
    :button TEXTEDITQUIT :label "Quit without saving file" :command Edit_Xlate_quit
    :show T

    :modify TEXTEDIT :strings "$text" :see 0

   vwait __editxlatedone

   if {$__editxlatedone == 1}  {
       set text "[[:path TEXTEDIT].text get 1.0 end]"
   } else {
       set text ""
   }

   destroy "[self frame-name].textedit"

   return $text
}

proc Edit_Xlate_done {} {global __editxlatedone; set __editxlatedone 1}
proc Edit_Xlate_quit {} {global __editxlatedone; set __editxlatedone 2}

proc edit_xlate {} {
    global sortfilename

    set line     ""
    set contents ""

    set z [ catch {open $sortfilename r} f ]
    if { $z != 0 } then {
        midas-warning "Unable to open file $sortfilename\n$f"
        return
    } else {
       foreach line [ split [ read $f ] \n ] {
         append contents $line "\n" 
       }
       close $f
    }

    set contents [Edit_Xlate $contents ]
 
    if {$contents == ""} then {return}
   
    set z [ catch {open $sortfilename w} f ]
    if {$z != 0} then {
        midas-warning "Unable to write file $sortfilename\n$f"
        return
    } else {
        puts $f "$contents"
    }
    close $f
    set contents ""
    set-footer "$sortfilename updated"

    :modify STATE :label "To BE Compiled"
    :modify BCOMPILE :inactive F

    UpdateRunState
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> compile_sortfile.tcl                                    <--#
#-->                                                         <--#
#--> This routine compiles your sort program.                <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc make.f {f} {
    global env sortfilename execfilename
    global usegcc usegfortran


        puts $f "#===========================================================#"
        puts $f "#---> Automagically created makefile for midassort"
        puts $f "#---> Do NOT modifiy this file"
        puts $f "#===========================================================#"
        puts $f "        MIDAS = $env(MIDASBASE)"
        puts $f "        MIDASSORT = $env(MIDASsortBase)"
        puts $f "        INC = -I$env(MIDASsortBase)/include -I[file dirname $sortfilename]"
        
    switch $env(os) {
       SunOS {
          if {$usegcc == 0} {
              puts $f "        LIBDIR = [file join $env(MIDASsortBase) SunOS lib_cc]"
              puts $f "        OBJS  = [file join $env(MIDASsortBase) SunOS lib_cc smf-sm.a]"
          } else {
              puts $f "        LIBDIR = [file join $env(MIDASsortBase) SunOS  lib_gcc]"
              puts $f "        OBJS  = [file join $env(MIDASsortBase) SunOS  lib_gcc smf-sm.a]"
          }
       }
       Linux64 {
          puts $f "        LIBDIR = [file join $env(MIDASsortBase) Linux lib64]"
          puts $f "        OBJS  = [file join $env(MIDASsortBase) Linux lib64 smf-sm.a]"
       }
       Linux {
          puts $f "        LIBDIR = [file join $env(MIDASsortBase) Linux lib]"
          puts $f "        OBJS  = [file join $env(MIDASsortBase) Linux lib smf-sm.a]"
       }
       Win {
              puts $f "        CYGWINDIR = [file join $env(MIDASsortBase) Cygwin bin]"
              puts $f "        LIBDIR = [file join $env(MIDASsortBase) Win bin]"
              puts $f "        OBJS  = \$(CYGWINDIR)/sort-main.o \$(CYGWINDIR)/end_prog.o"
       }
    }
    
    puts $f "#--> ======================================================= <--#"
    puts $f "#--> Compiler options"

           if {$usegcc || $env(os)=="Linux" || $env(os)=="Linux64"} then {
               if {$usegfortran} {
if {$env(gcc44)} then {
                    puts $f "            F77 = gfortran44"
} else {
                    puts $f "            F77 = gfortran"
}
               } else {
                   puts $f "            F77 = g77"
               }
               if {$env(os) == "Linux64"} then {
                   puts $f "         COPTS = -m64 -O"
               } else {
                   puts $f "         COPTS = -m32 -O"
               }
           } else {
               puts $f "            F77 = f77"
               puts $f "         COPTS = -O"
           }
        
    switch $env(os) {
       SunOS -
       Linux64 -
       Linux {
            puts $f "        XTRA = \$(LIBDIR)/fortconvert.o"
        }
       Win {
            puts $f "        XTRA = \$(CYGWINDIR)/fortconvert.o"
       }
    }

        puts $f "#--> ======================================================= <--#"
        puts $f "#--> Library options"

    switch $env(os) {
       SunOS  {
          puts $f "        MIDASL = [file join $env(MIDASBASE) lib_SunOS]"
          puts $f "        MIDASI = [file join $env(MIDASBASE) include]"
          puts $f "      CPPFLAGS = \$(INC) -I\$(MIDASI) -I./"
       }
       Linux64  {
          puts $f "        MIDASL = [file join $env(MIDASBASE) lib_Linux64]"
          puts $f "        MIDASI = [file join $env(MIDASBASE) include]"
          puts $f "      CPPFLAGS = \$(INC) -I\$(MIDASI) -I./"
       }
       Linux  {
          puts $f "        MIDASL = [file join $env(MIDASBASE) lib_Linux]"
          puts $f "        MIDASI = [file join $env(MIDASBASE) include]"
          puts $f "      CPPFLAGS = \$(INC) -I\$(MIDASI) -I./"
       }
       Win {
          puts $f "        MIDASL = [file join $env(MIDASBASE) bin_Win]"
          puts $f "        MIDASI = [file join $env(MIDASBASE) include]"          
          puts $f "      CPPFLAGS = \$(INC) -I\$(MIDASI) -I./  -DCYGWIN"
       }
    }

        switch $env(os)  {
           SunOS   {        
              puts $f "        LDLIBS = -R/usr/ucblib -L/usr/ucblib -R\$(MIDASL) \\"
              puts $f "        -L\$(MIDASL) -R\$(LIBDIR) -L\$(LIBDIR) \\"
              puts $f "           -leg -lsasdirect -lgetspecmem -lnetvar -lglobals -lrt -ldl -lm"
           }
           Linux64 -
           Linux   {        
              puts $f "        LDLIBS = -L\$(MIDASL) -L\$(LIBDIR) \\"
              puts $f "          -leg -lsasdirect -lgetspecmem -lnetvar -lglobals -lrt -ldl -lm"
           }
           Win   { 
              puts $f "        LDLIBS = -L\$(CYGWINDIR) -L\$(LIBDIR) -L\$(MIDASL) \\"
              puts $f "           -leg -lgetspecmem -lglobals -lMIDASsortL -lMIDASsortS"
           }
           default {}
        }

    puts $f "#--> ======================================================= <--#"
#    Caution - Don't edit out hidden tab  -   nasty make feature
    puts $f "clean:"
    puts $f "	rm -f $execfilename"
    puts $f "all:"
    puts $f "	\$(F77) \$(COPTS) \$(CPPFLAGS) -c sort-midas-user.f"
    puts $f "	\$(F77) \$(COPTS) -o $execfilename sort-midas-user.o \$(XTRA) \$(OBJS) \$(LDLIBS) "
}

proc make.c {f} {
    global env sortfilename execfilename
    global usegcc

        puts $f "#===========================================================#"
        puts $f "#---> Automagically created makefile for midassort"
        puts $f "#---> Do NOT modifiy this file"
        puts $f "#===========================================================#"
        puts $f "        MIDAS = $env(MIDASBASE)"
        puts $f "        MIDASSORT = $env(MIDASsortBase)"
        puts $f "        INC = -I$env(MIDASsortBase)/include -I[file dirname $sortfilename]"
        
    switch $env(os) {
       SunOS {
          if {$usegcc == 0} {
              puts $f "        LIBDIR = [file join $env(MIDASsortBase) SunOS lib_cc]"
              puts $f "        OBJS  = [file join $env(MIDASsortBase) SunOS lib_cc smf-sm.a]"
          } else {
              puts $f "        LIBDIR = [file join $env(MIDASsortBase) SunOS  lib_gcc]"
              puts $f "        OBJS  = [file join $env(MIDASsortBase) SunOS  lib_gcc smf-sm.a]"
          }
       }
       Linux64 {
          puts $f "        LIBDIR = [file join $env(MIDASsortBase) Linux lib64]"
          puts $f "        OBJS  = [file join $env(MIDASsortBase) Linux lib64 smf-sm.a]"
       }
       Linux {
          puts $f "        LIBDIR = [file join $env(MIDASsortBase) Linux lib]"
          puts $f "        OBJS  = [file join $env(MIDASsortBase) Linux lib smf-sm.a]"
       }
       Win {
          if {$usegcc} then {
              puts $f "        CYGWINDIR = [file join $env(MIDASsortBase) Cygwin bin]"
              puts $f "        LIBDIR = [file join $env(MIDASsortBase) Win bin]"
              puts $f "        OBJS  = \$(CYGWINDIR)/sort-main.o \$(CYGWINDIR)/end_prog.o"
          } else {
#    This path should never get used
          }
       }
       default {}
    }
       
          puts $f "#--> ======================================================= <--#"
          puts $f "#--> Compiler options"

        if {$usegcc == 1 || $env(os) == "Linux" || $env(os) == "Linux64"} then {
            if {$env(os) == "Linux64"} then {
if {$env(gcc44)} then {
                  puts $f "         CC = gcc44 -m64"
} else {
                  puts $f "         CC = gcc -m64"
}
            } else {
if {$env(gcc44)} then {
                  puts $f "         CC = gcc44 -m32"
} else {
                  puts $f "         CC = gcc -m32"
}
            }
            puts $f "         COPTS = -O"
        } else {
            puts $f "         CC = cc"
            puts $f "         COPTS = -O"
        }

        puts $f "#--> ======================================================= <--#"
        puts $f "#--> Library options"
        
    switch $env(os) {
       SunOS  {
          puts $f "        MIDASL = [file join $env(MIDASBASE) lib_SunOS]"
          puts $f "        MIDASI = [file join $env(MIDASBASE) include]"
          puts $f "      CPPFLAGS = \$(INC) -I\$(MIDASI) -I./"
       }
       Linux64  {
          puts $f "        MIDASL = [file join $env(MIDASBASE) lib_Linux64]"
          puts $f "        MIDASI = [file join $env(MIDASBASE) include]"
          puts $f "      CPPFLAGS = \$(INC) -I\$(MIDASI) -I./"
       }
       Linux  {
          puts $f "        MIDASL = [file join $env(MIDASBASE) lib_Linux]"
          puts $f "        MIDASI = [file join $env(MIDASBASE) include]"
          puts $f "      CPPFLAGS = \$(INC) -I\$(MIDASI) -I./"
       }
       Win {
          puts $f "        MIDASL = [file join $env(MIDASBASE) bin_Win]"
          puts $f "        MIDASI = [file join $env(MIDASBASE) include]"
          if {$usegcc} then {            
             puts $f "      CPPFLAGS = \$(INC) -I\$(MIDASI) -I./  -DCYGWIN"
          } else {
#    This path should never get used  
          }
       }
       default {}
    }
    
        switch $env(os)  {
           SunOS   {        
               puts $f "        LDLIBS = -R/usr/ucblib -L/usr/ucblib -R\$(MIDASL) \\"
               puts $f "        -L\$(MIDASL) -R\$(LIBDIR) -L\$(LIBDIR) \\"
               puts $f "           -leg -lsasdirect -lgetspecmem -lnetvar -lglobals -lrt -ldl -lm"
           }
           Linux64 -
           Linux   {            
               puts $f "        LDLIBS = -L\$(LIBDIR) -L\$(MIDASL) \\"
               puts $f "          -leg -lsasdirect -lgetspecmem -lnetvar -lglobals -lrt -ldl -lm"
           }
           Win   {
               if {$usegcc} then {            
                   puts $f "        LDLIBS = -L\$(CYGWINDIR) -L\$(LIBDIR) -L\$(MIDASL) \\"
                   puts $f "           -leg -lgetspecmem -lglobals -lMIDASsortL -lMIDASsortS"
               } else {
#    This path should never get used         
               }
           }
           default {}
        }

    puts $f "#--> ======================================================= <--#"
#    Caution - Don't edit out hidden tab  -   nasty make feature
    puts $f "clean:"
    puts $f "	rm -f $execfilename"
    puts $f "all:"
    puts $f "	\$(CC) \$(COPTS) \$(CPPFLAGS) -c sort-midas-user.c"
    puts $f "	\$(CC) \$(COPTS) -o $execfilename sort-midas-user.o  \$(OBJS) \$(LDLIBS)"
}

proc winmake.c {} {
    global env sortfilename execfilename
    
    set INCDIR "/I \"[file join $env(MIDASsortBase) include]\" /I \"[file dirname $sortfilename]\""
    set SORTLIBDIR "[file join $env(MIDASsortBase) Win bin]"

    set SOBJS "$SORTLIBDIR/sort-main.obj $SORTLIBDIR/end_prog.obj"
    set SYSLIBS "wsock32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib"

    file delete sort-midas-user.obj
    set rc1 [catch {eval exec cl  /ML /W3 /GX $INCDIR /D WIN32 /D NDEBUG /D "_CONSOLE" /D "_MBCS" /YX /FD /c sort-midas-user.c} m1]
    if {![file exists sort-midas-user.obj]} {return "$m1\n\n**** Compilation failed ****"}

    file delete $execfilename
    set rc2 [catch {eval exec link globals.lib libeg.lib MIDASsortS.lib MIDASsortL.lib $SYSLIBS  /subsystem:console /incremental:no /pdb:"midassort.pdb" /machine:I386  /libpath:$SORTLIBDIR /out:$execfilename sort-midas-user.obj $SOBJS} m2]
    if {![file exists $execfilename]} {return "$m1\n$m2\n\n**** Link failed ****"}
    
    return "$m1\n$m2\n\nMake Successful"
}

proc compile_sortfile args {
    global env sortfilename compileoptions execfilename
    global file_status
    global makefilepath
    global mydebug
    global usegcc
    global usesssnc

    :modify LIST :empty T
    update idletasks

    if { $usesssnc == 1 } then {set co2 "-usesssnc"} else {set co2 ""}
    
#    this no longer actually does the compile  - it does however parse the user sort program and 
#    create the file containing histograms to be used

    set rc [catch { exec compile_midas_sort $sortfilename $co2 } m]    

    set response "$m"
    if {$rc != 0} then {abort_report}
    
    if {$response == "OK"} then {      ;#   write the make file and execute it

        if {[midas-check-for-temp] == 0} then {return}   ;#    This contains cd to a temp directory
        
        if {$env(os) == "Win" && $usegcc == 0} {
            if {[file extension $sortfilename] == ".f" || [file extension $sortfilename] == ".F"} then {
                midas-warning "No Microsoft Fortran compiler is supported.\nSuggest you use Cygwin and GCC compilers"
                return
            } else {
                set rc [catch {winmake.c} m]     ;# special using the Microsoft C++ compiler
            }
        } else {
            set z [catch {open make.midas_sort w} f1]
            if {$z != 0} then {
                set m "Unable to write make.midas_sort\n$f1"
                midas-warning "$m"
            } else {
                if {[file extension $sortfilename] == ".f" || [file extension $sortfilename] == ".F"}  \
                            then {make.f $f1} else {make.c $f1}
                close $f1
                set rc [catch {exec make -f make.midas_sort clean all} m]
                if {[file exists $execfilename]} {append m "\n\nMake Successful"} else {append m "\n\n**** Make Failed ****"}
             }
         }
    }
    
    insert-list $m

    switch [filestatus_midas_sort] {
    0     { set file_status "To BE Compiled" }
    1     { set file_status "Compiled"}
    2     { set file_status "Exe file older than src" }
    3     { set file_status "Please recomplile"}
    }

    :modify STATE :label $file_status
    
    UpdateRunState
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc abort_report {} {
   global abortflag

   set-footer "program terminated abnormally"
   set message "program terminated abnormally\n\
      "
   if {[string length $message] < 1000} then {
      set abortflag [midas-confirmation "$message" "Ok"]
   } else {
      midas-information "$message"
      set abortflag [midas-confirmation "report has been placed in separate window because of its size" "Ok" ]
   }
}

proc setstatus {} {
    global running

#--> The status of the sort program can be obtained from the
#--> file sort.status in the tmp dir in which we are running.
    midas-check-for-temp
    set z [ catch { open "sort.status" r } f ]
    if { $z != 0 } then {
    #--> As we can not read the file, the sort can not be running
        set running 0
    } else {
        gets $f running
        close $f
    }
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> StartSort.tcl                                             <--#
#-->                                                         <--#
#--> This routine sets the sort going - go team !            <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc StartSort args {
    global env execfilename SortPid
    global running
    global paused
    global input_type idf file_list
    global data_type
    global mydebug
    global overwritespec
    global debugsort
    global started
    global configtable
    global debuglevel
    global thist
    global usegcc
    
    set so3 ""
    set so4 ""
    set so5 ""
    
    setstatus

    if { $running == 0 } then {
#--> ok we know need to set up our command line arguments
#--> First, where are we reading from .... data that is ...
       set so3 "/dev/null"
       switch $input_type {
          "Disc"    {set so1 "disc"}
          "Online"  {set so1 "midasTS"}
          "GANILOnline"  {set so1 "GANILOnline"}
          "Tape"    {set so1 "tape"; set so3 $idf}
       }
#--> Now what is the format of the data we are reading ..?
       switch $data_type {
           0    {set so2 "midas_fmt"}
           1    {set so2 "eurogam_fmt"}
           2    {set so2 "grain"}
           3    {set so2 "exogam_fmt"}
           4    {set so2 "great_fmt"}
           5    { if {$env(os) == "Linux" || $env(os) == "Linux64"} then {
                   set so2 "great_eb_fmt"
                  } else {
                   set so2 "great_eb_fmt"
#                   set so2 "null"
                  }
                }
           6    { if {$env(os) == "Linux" || $env(os) == "Linux64"} then {
                   set so2 "null"
                  } else {
                   set so2 "midas_fmt"
                  }
                }
           default {set so2 "midas_fmt"}
       }

#--> Do we want to overwrite any existing spectra ?
       if { $overwritespec == 0 } then {
          set so4 "-addspec"
       } else {
          set so4 "-newspec"
       }

#--> Do we want to start off with debugging enabled ?
       if { $debugsort == 1 } then {
          set so5 "1"
       } else {
          set so5 "0"
       }

       setthist W $thist     ;#    set histogramming flag

#    check status of our spectra

       create_spectra

#--> Make sure we have some DEBUG info saved ...
       save_debug_levels

       global SortCmd
       set SortCmd "$execfilename -debug $so5 -idev $so1 -ifmt $so2 $so4 -cft $configtable -tdev $so3"

       midas-check-for-temp        ;#    This contains cd to a temp directory

       switch $env(os) {
          SunOS  -
          Linux64 -
          Linux  {

             set z [catch {open midas_sort.cmd w} f]
             if {$z != 0} then {
                set m "Unable to write midas_sort.cmd\n$f"
                midas-warning "$m"
             } else {
                puts $f "#!/bin/csh -f"
                puts $f "setenv EXPERIMENTDIR $env(EXPERIMENTDIR)"
                puts $f "setenv MIDASBASE $env(MIDASBASE)"
                puts $f "setenv MIDASsortBase $env(MIDASsortBase)"
                puts $f "setenv MSPLUGINDIR $env(MSPLUGINDIR)"
                puts $f "setenv PATH $env(PATH)"
                puts $f "setenv LD_LIBRARY_PATH $env(LD_LIBRARY_PATH)"
                puts $f "setenv MSPWD $env(MSPWD)"
                puts $f "nice $SortCmd"
                close $f
                insert-list "Command file written to [file join [pwd] midas_sort.cmd]"
             }

             set z [catch { exec nice $execfilename "-debug" $so5 "-idev" $so1 "-ifmt" $so2 $so4 "-cft" $configtable "-tdev" $so3 & } m]
          }
          Win   {

             set z [catch {open midas_sort.cmd w} f]
             if {$z != 0} then {
                set m "Unable to write midas_sort.cmd\n$f"
                midas-warning "$m"
             } else {
                puts $f "set EXPERIMENTDIR=$env(EXPERIMENTDIR)"
                puts $f "set MIDASBASE=$env(MIDASBASE)"
                puts $f "set MIDASsortBase=$env(MIDASsortBase)"
                puts $f "set MSPLUGINDIR=$env(MSPLUGINDIR)"
                puts $f "set PATH=$env(PATH)"
                puts $f "set LD_LIBRARY_PATH=$env(LD_LIBRARY_PATH)"
                puts $f "set MSPWD=$env(MSPWD)"
                puts $f "$SortCmd"
                close $f
                insert-list "Command file written to [file join [pwd] midas_sort.cmd]"
             }

             set z [catch { exec cmd.exe /K "$execfilename -debug $so5 -idev $so1 -ifmt $so2 $so4 -cft $configtable -tdev $so3" & } m] 
          }
       }
    
       if {$z != 0} {
          insert-list $m
          :modify MSRSTATE :label "Start Error run"
          set SortPid 0
       } else {
          set SortPid $m
          :modify MSRSTATE :label "Started (pid=$SortPid)"
          :modify BSTOP    :label "Pause"
          :modify BSTART   :inactive T
          set running 1
          update idletasks
          inable 0
#--> Start the refresh deamon ....
          after 2000 get_after_status 1
      }
    } else  {
      if { $paused == 1 } then {
         :modify MSRSTATE :label "Running"
         :modify BSTART   :label "Continue"
         :modify BSTART   :inactive T
         :modify BSTOP    :label "Pause"
        
         update idletasks
         set rc [catch { exec midasSortshm w 1 0 } m]
         if {$rc != 0} {midas-warning "Action failed: $m"; return}
#         insert-log "midasSortshm returned $m"
         set paused 0
      }
    }
}

proc create_spectra {} {
    global overwritespec

    midas-check-for-temp
    set z [ catch {open specarray r} f ]
    if { $z != 0 } then {
        midas-warning "Unable to open specarray file\n$f"
        return
    } else {
       foreach line [ split [ read $f ] \n ] {
           if {[string length $line] < 2} {continue}
           set Id [first $line]
           if {$Id == "#"} {continue}
           set Name [second $line]
           set Type [third $line]
           set Len [fourth $line]
           set CreateNeeded 0
#    see if the histogram already exists and obtain details
           set z [catch {eg "(spectrum :path '/SortSas' :name '$Name' ?spec)" } m]
           if {$z == 0} {
#    histogram exists - check compatible with what we want
               if {$Type == [first $m] && $Len == [first [third $m]]} then {
#    type and size OK
                   if {$overwritespec == 1} then {
#    Overwrite existing histogram
                       set z [catch {eg "(spectrum :path '/SortSas' :name '$Name' !zero)" } m]
                       if {$z!=0} then {
                           display-eg-error-report self $m "Attempting to zero spectrum $Name"
                       } 
                   } else {
#    Append to existing histogram - nothing to do
                   }
               } else {
#    size and type incompatible
                   if {$overwritespec == 1} then {
#    Overwrite existing histogram  -  can delete and recreate
                       set z [catch {eg "(spectrum :path '/SortSas' :name '$Name' !delete)" } m]
                       if {$z!=0} then {
                           display-eg-error-report self $m "Attempting to delete spectrum $Name"
                       } 
                       set CreateNeeded 1
                   } else {
#    Append to existing histogram is questionable since options differ
                          midas-warning "Histogram $Name is currently type $Type and length $Len but you want type $Type and length $Len\n
Perhaps you should request Overwrite to delete and recreate"
                   }
               }
           } else {
#    unable to query histogram - possibly does not exist
               set CreateNeeded 1
           }
#    now create if needed
           if {$CreateNeeded == 1} {
               if {$Type == 1} {
                   set z [catch {eg "(spectrum :path '/SortSas' :range $Len :name '$Name' !new)" } m]
               } else {
                   set z [catch {eg "(spectrum :path '/SortSas' :range $Len :range2 $Len :type 5 :name '$Name' !new)" } m]
               }
               if {$z!=0} then {
                    display-eg-error-report self $m "Attempting to create spectrum $Name"
               }
           }
       }
       close $f
    }
}


#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> StopSort.tcl                                         <--#
#-->                                                         <--#
#--> This routine either pauses the sort or kills it         <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc StopSort args {
    global execfilename
    global running
    global paused
    global started
    global mydebug
    
    setstatus

    if { $running == 1 } then {
       if { $paused == 0} then {

          set rc [catch { exec midasSortshm w 1 1 } m]
          if {$rc != 0} {midas-warning "Action failed: $m"; return}
#          insert-log "midasSortshm returned $m"

          :modify MSRSTATE :label "Paused"
          :modify BSTART   :label "Continue" :inactive F
          :modify BSTOP    :label "Kill"

          update idletasks
       
          set paused 1
        
       } else {

          if {$paused == 1} {

              set rc [catch { exec midasSortshm w 1 -1 } m]
              if {$rc != 0} {midas-warning "Action failed: $m"; return}
#              insert-log "midasSortshm returned $m"

              :modify MSRSTATE :label "Killed"
              :modify BSTART   :label "Start"
              :modify BSTOP    :label "Stop"

              set running 0
              set paused 0
              inable 1
              update idletasks
              set running 0
          }
       }
    } else {
       :modify MSRSTATE :label "NOT running"
       :modify BSTART :inactive F
       :modify BSTOP :inactive F

       inable 1
    
       set running 0
       set paused 0
       set started 0
       update idletasks
    }
} 
 

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> status.tcl                                              <--#
#-->                                                         <--#
#--> This routine determine the status of the system         <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc status {} {
    global running SortPid
    global paused
    
    setstatus

    if { $running == 0 } then {
        :modify MSRSTATE :label "NOT running"
        :modify BSTART :inactive F
        :modify BSTOP :inactive F
    } elseif { $running == 1 } then {
        :modify MSRSTATE :label "Running (pid=$SortPid)"
        if { $paused == 1 } then {
             :modify MSRSTATE :label "Paused"
        }
    }
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> insert-list.tcl                                         <--#
#-->                                                         <--#
#--> This routine writes data to the GALLEY (LIST)           <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc insert-list {s} {

    :modify LIST :strings "\n"
    :modify LIST :strings "$s\n"

}

proc inable arg {

    if { $arg == 0 } then {
    :modify CSMEDIA     :inactive T
#    :modify CSMEDIAO    :inactive T
    :modify CSFMT       :inactive T
#    :modify CSFMTO      :inactive T
    :modify BIMEDIADATA :inactive T
    :modify CSOS        :inactive T
    :modify BSETTINGS   :inactive T
    :modify BSPECTRA    :inactive F
#    :modify BSTATUS     :inactive F
    :modify BSTOP       :inactive F
    :modify BCOMPILE    :inactive T
    :modify BBROWSE     :inactive T
    } else {
    :modify CSMEDIA     :inactive F
#    :modify CSMEDIAO    :inactive F
    :modify CSFMT       :inactive F
#    :modify CSFMTO      :inactive F
    :modify BIMEDIADATA :inactive F
    :modify CSOS        :inactive F
    :modify BSETTINGS   :inactive F
#    :modify BSTATUS     :inactive T
    :modify BSTOP       :inactive T
    :modify BCOMPILE    :inactive F
    :modify BBROWSE     :inactive F
    }
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> setthist.tcl                                            <--#
#-->                                                         <--#
#--> This tcl file toggles histogramming                     <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setthist {w vl} {
    global thist

    set rc [ catch { exec midasSortshm w 3 $vl } m]
    if {$rc != 0} {midas-warning "Action failed: $m"; return}
    set thist $vl
}

#--> This routine checks the status of the sort and updates  <--#
#--> the GUI as required ......                              <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc get_after_status args {
    global running SortPid
    global paused
    global started
    global mydebug
    global update_time

    setstatus

#--> So what do we need to do ....?
    if { $running == 1 } then {
        if { $paused == 0 } then {
#--> System is running happily ...
        :modify MSRSTATE :label "Running (pid=$SortPid)"
        } else {
#--> Sort is running, but the user has paused things at the moment
        :modify MSRSTATE :label "Paused"
        }
    } else {
#--> We are not going .....
       :modify MSRSTATE :label "Stopped"
       :modify BSTART   :label "Start" :inactive F
       :modify BSTOP    :label "Stop"  :inactive T
       inable 1
       set paused 0
    }
#--> Next question .... do we want to check again in a bit ..
#--> only if the sort is actually running
    if { $running == 1 } then {
    after $update_time get_after_status
    }

#--> now reset the footer
    set-footer MIDASsort "Display updated at : [clock format [clock seconds]  -format %m.%d.%y\ %H:%M:%S ] "
}

#--> ======================================================= <--#
#--> developer.tcl this file will generate a GUI that will   <--#
#-->               allow the enviroment variables to be set  <--#
#-->               so that a developer can test the software <--#
#-->               prior to releasing the code to the world  <--#
#--> ======================================================= <--#

proc developer {} {
    global env
    global csdev0value
    global shmstrings shmvalue shmconstant

    :frame FDEVELOPER :label "MIDASsort - Development enviroment" :resize F :transient T
     :panel PDEV0 :layout V :padx 5 :pady 5
      :layout H
      :message MDEV0 :label  "MIDASsort - Development enviroment"
      :next-row T
      :next-row T
      :message MDEV1   :label "Enable MIDASsort tcl debugging" 
      :checkbox CBDEV0 :label "" :value $mydebug
      :next-row T
      :message MDEV2   :label "Shared Memory Control " 
      :hskip 25
      :choice-stack CSDEV0 :label " " :strings "Read Write" :value   $csdev0value
      :choice-stack CSDEV1 :label "Variable" :strings $shmstring :value $shmvalue
      :number NDEV0        :label "Value"  :value $shmconstant :w 3 :valuex 5c
      :button BDEV0        :label "Execute" :valuex 12c :command Dev_Execute
      :next-row T
      :message MDEV3 :label "Plugin Module Directory"
      :text TDEV0    :label "" :value $env(MSPLUGINDIR) :w 50
      :next-row T
      :next-row T
      :button :BDEV1 :label "Refresh" :valuex 12c :command Dev_Refresh
      :button BDEV2  :label "Leave" :valuex 12c :command Dev_Leave

    :show T
}

proc Dev_Execute args {
    global shmvalue shmconstant shmindex

     if {$csdev0value == 0 || $shmconstant == 0} {
         set rc [ catch { exec midasSortshm r [lindex $shmindex $shmvalue] $shmconstant } m ]
     } else {
         set rc [ catch { exec "midasSortshm" w [lindex $shmindex $shmvalue] $shmconstant } m ]
     }
     if {$rc != 0} {midas-warning "Action failed: $m"; return}
     midas-report "$m"
}

proc Dev_Leave {} {

    destroy-frame FDEVELOPER
}

proc Dev_Refresh {} {
    global env

    :modify CBDEV0 :value $mydebug
    :modify TDEV0  :value $env(MSPLUGINDIR)
}

proc UpdateRunState {} {
  global _classname imedia

  if {![info exists _classname(state)]} {return}
  if {![info exists _classname(stated)]} {return}
  if {![info exists _classname(bstart)]} {return}

   catch {
     if {[:query STATE :label] == "Compiled"} then {
        if {[:query STATED :label] == "Files input" || [:query STATED :label] == "Good Connection" || $imedia == 3}  \
            then {:modify BSTART :inactive F} else {:modify BSTART :inactive T}
     } else {:modify BSTART :inactive T}
         }
}


#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> click.tcl                                               <--#
#-->                                                         <--#
#--> This tcl file handles the direct typing of the          <--#
#--> parameters   into the control window.                   <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc click arg {
    global env imedia
    global data_type numitapes imedianum simedianame 
    global bfmt atext dtext ffmt
    global overwritespec
    global update update_time
    global vdaspos vdpos
    global csdev0value shmstrings shmvalue shmconstant

    set f [lindex $arg 0]
    set c [lindex $arg 1]
    set w [lindex $arg 2]
    set v [lindex $arg 3]
    set i [lindex $arg 4]

    switch -glob $w  {
    TSORTFILE        { tsortfile $v }
    CSMEDIA          { input_media $i }
    IMEDIALIST       { choice-imedia $i }
    CBTO             { enable_set_trace $v }
    CSTO             { set_trace_level $i }
    CSDISK           { csdisk $v }
    LDISK            { select-item $i }
    
    BIMEDIADATA      {
            if {$imedia == 0} {tape_info}
            if {$imedia == 1} {disk_info}
        }
    
    CSFMT            { set data_type $v }
    CSOS             { set overwritespec $v }
    NIMEDIATAPES     { set numitapes $v }
    NIMEDIAVAL       { set imedianum $v }
    TIMEDIANAME      { set simedianame $v }
    CSMEDIAD         { set ffmt $v }
    NIMEDIADTAPES    { set numitapes $v }
    TTEXTD1          { set dtext $v }
    TTEXTD2          { set atext $v }
    CSMEDIADLEN      { set bfmt $i }
    CSVD1            { set vdpos $v ; viewData.redisplay }
    CSVD2            { set vdaspos $v ; viewData.redisplay }

    CSDISK1          { set bfmt $i }
    TDISK            { set dtext $v }
    TDISK1           { set atext $v }

    CSDDSO           { set update $v ; set update_time [ expr $i * 1000 ] }
    TUV*             { global uv[string range $w 3 end]; set uv[string range $w 3 end] $v }

    CSDEV0           { set csdev0value $v }
    CSDEV1           { set shmvalue $v }
    NDEV0            { set shmconstant $v }
    TDEV0            { set env(MSPLUGINDIR) $v }
    
    default {}
    }

    UpdateRunState
}

proc finish {args} {ExitSort}

proc click-configure args {UpdateRunState}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#-->                                                         <--#
#--> Leave sort frame ... tidy things up ....                <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 17/06/03                       <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc ExitSort {} {
    global kmemsas
    global userexpt
    global env

     StopSort
     StopSort        ;#  twice so that if a Sort is running it gets Paused and Killed

    if { $userexpt == 1 && $env(platform) != "windows"} then {
    
      if { $kmemsas == 1 } then {kill_memsas}
      
      set filename "capabilities"
      set experiment "midassort"
      set directory [file join $env(MIDASTempDir) tcl[pid]]
      global EGallow; set EGallow 0x10008; :experiment disconnect; set EGallow -1
      catch {unset env(EXPERIMENTDIR)}
      catch {unset env(EXPERIMENTBASE)}
      set z [catch {:file delete -r [file join $directory $experiment]} m]
      if {$z!=0} then {midas-error "" "Experiment $experiment not deleted" $m}
    }

     SavePreferences

     set started 0
     close-frame
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Procedure to setup and draw the GUI                     <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc start args {
    global started preferences Build
    global input_type
    global env
    global mydebug

    if { $started == 0 } then {

       midas-check-for-temp     ;#  will cd into temp directory 

       image create photo ring -format gif -file [ file join $env(MIDASsortBase) logo.gif ]
       splash_create ring "MIDASsort Build $Build" " Contact V.Pucknell \n(pucknell@dl.ac.uk)\n  for more details  " "Initialising ..."
      
       set env(MSPWD) /SHM_MIDASsort[string range [file tail [pwd]] 3 end]

       splash_update "Preferences loading ...."
       LoadPreferences
       
       splash_update "Checking enviroment for a valid EXPERIMENT  ....."
       check_experiment

       splash_update "Checking for memsas server ....."
       check_server
       
       set_colour
    
       make-frame
       
       splash_remove
        
       input_media $input_type
    } else {
       open-frame
    }

    set started 1
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc make-initial-frame {} {

    :frame [self frame-name] :label "[self frame-title]" :icon-name "[self icon-title]"
     :message MIDASSORT 
}

make-initial-frame    ;# acts as parent for any error popups until make-frame


#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Procedure to define the layout of our GUI               <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc make-frame {} {
    global mediastring fmtstring tstring
    global srstate
    global sortfilename directory
    global input_type idf data_type
    global output_type odf
    global ssavedir
    global overwritespec
    global thist
    global indev infmt

    :frame [self frame-name] :label "[self frame-title]" :show-footer T \
        :icon-name "[self icon-title]" :resize F

    :panel PH1 :layout L :padx 5 :pady 5
     :layout H; :row-gap 10; :col-gap 15
     :message MSORT :label "Sort Setup" :bold T :colour "-fg black"

     :next-row T
#--> Sortfile input name
     :text TSORTFILE :label "Sortfile:" :shifters T  :value $sortfilename
     :button BBROWSE :label "Browse" :command browse_sortfile
     :col-gap 5
     :message MS    :label "State:" :bold T
     :message STATE :label "Not Choosen"

     :next-row T
     :col-gap 15
     :button BEDITFILE :label "Edit Sortfile"      :w 12   :command edit_xlate
     :button BCOMPILE  :label "Compile Sortfile"   :w 12 :inactive T  :command compile_sortfile
     :button BSETTINGS :label "Settings"           :w 12   :command get_settings
     :button BSOPTS    :label "Sort Options"       :w 12   :command sort_options

     :col-gap 5

     :next-row T
#--> Input Stream / Data Format / Upper and lower run numbers
     :hskip 5
     :choice-stack CSMEDIA :label "Input Media" :strings $mediastring  :value [lsearch $mediastring $input_type]
     :hskip 40
     :choice-stack CSFMT :label "Data Format" :strings $fmtstring  :value $data_type
     :hskip 20
     :button BIMEDIADATA :label "Tape Info" :w 12 :inactive F

     :next-row T
#--> Device/command input
     :text TDEVICE :label $tstring :valuex 9c :shifters T :value $idf
     :hskip 5
     :button BBROWSEDEV :label "Browse"  :command input_browse_device
     :hskip 5
     :message MSD :label "State:" :bold T
     :message STATED :label "Not Selected"

     :next-row T
#--> Output Stream / Data Format
     :hskip 5
     :choice-stack CSMEDIAO :label "Output Media" :strings "NULL" :inactive T
     :hskip 40
     :choice-stack CSFMTO :label "Data Format" :strings "NULL" :rows 5 :inactive T

     :next-row T
#--> Device/command input
     :text TDEVICEO :label $tstring :valuex 9c :shifters T :value $odf :inactive T
     :hskip 5
     :button BBROWSEDEVO :label "Browse" :inactive T
     :hskip 5
     :message MSDO :label "State:" :bold T
     :message STATEDO :label ""

     :next-row T
#--> Spectrum Control
     :message MSPEC :label "Spectrum Control" :bold T :colour "-fg black"

     :next-row T
     :checkbox CSOS :label "Overwrite Existing Spectra" :value $overwritespec :valuex 25c
     :button BSPECTRA  :label "View Spectra"       :w 12  :inactive T  :command "inform sb sfmstart SortSas"

     :next-row T
     :checkbox CBTHIST :label "Enable Histogramming" :value $thist :valuex 25c :command setthist

     :next-row T
#--> Some Control Buttons
     :message MSRUN :label "Sort Control" :bold T :colour "-fg black"
     :message MSRSTATE :label $srstate :bold T 

     :next-row T
     :button BSTART    :label "Start"  :w 12 :inactive T  :command StartSort
     :button BSTOP     :label "Stop"   :w 12 :inactive T  :command StopSort
     :hskip 160
     :button BQUIT     :label "Exit"   :w 12   :command ExitSort

    :panel P3 :layout B :padx 5 :pady 5 :after FOOTER
     :galley LIST :cols 50 :rows 8 :deaf T  :font variable
     open-frame
     :galley_size LIST 8 50

    bind [:path BSOPTS] <ButtonPress-3>  "developer"

}


loadsource startup
loadsource memsas
loadsource settings
loadsource options
loadsource media
